=== debian/changelog ===
sleef (3.3.1-6) unstable; urgency=medium

  * Add symbols list for armel.

 -- Ximin Luo <infinity0@debian.org>  Sat, 26 Jan 2019 21:31:23 -0800

sleef (3.3.1-5) unstable; urgency=medium

  * Team upload.
  * Disable NEON on armel, fixing FTBFS there. Ignore erfc_u15 test failure.

 -- Ximin Luo <infinity0@debian.org>  Sat, 26 Jan 2019 21:12:42 -0800

sleef (3.3.1-4) unstable; urgency=medium

  * Override and noop dh_dwz since it failes on many architectures.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 13 Jan 2019 03:15:41 +0000

sleef (3.3.1-3) unstable; urgency=medium

  * Transfer packaging repo to Salsa/Science-team.
  * Set Maintainer as Science team, and move myself to Uploaders.
  * Bump Standards-Version to 4.3.0 (no change).
  * Bump debhelper compat to 12.
  * Let autopkgtest depends on build-essential, and make it amd64-specific.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 12 Jan 2019 06:09:05 +0000

sleef (3.3.1-2) unstable; urgency=medium

  * Add autopkgtest control file with a simple x86 testcase.
  * Bump Standards-Version to 4.2.1 (no change).
  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 29 Aug 2018 00:04:38 +0000

sleef (3.3.1-1) experimental; urgency=medium

  * New upstream version 3.3.1
  * Add symbols lists for: arm64, armhf, ppc64el, s390x, mips, mips64el,
    mipsel, alpha, hppa, ia64, powerpc, ppc64, powerpcspe, riscv64, sh4,
    and sparc64. Symbol lists are deduplicated with symlinks.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 23 Aug 2018 07:36:17 +0000

sleef (3.3-1) experimental; urgency=medium

  * Initial release. (Closes: #906248)

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 17 Aug 2018 04:23:59 +0000
